#ifndef FRAME_H
#define FRAME_H

#include <QWidget>
#include <QList>
#include "box.h"

struct coloredRect {
   QRect rect;
   QColor color;
};


class Frame : public QWidget
{
    Q_OBJECT
public:
    Frame(QWidget *parent = 0);
    QSize minimumSizeHint() const;
    QSize sizeHint() const;
    void setPriorDomain(Box&);
    void createConnections();
    double xToPix(double );
    double yToPix(double );

public slots:
    void addBox(Box&,QColor);
    //void setStepByStep(int);
    void clear();


protected:
    void paintEvent(QPaintEvent *event);

public:
    QList<coloredRect> l;
    Box priorDomain;
    double echx;
    double echy;
    int StepByStep;
    QLineF ax;
    QLineF ay;
    QPointF px1, px2, py1, py2;
};




#endif // FRAME_H
