

#include <QString>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <fstream>

#include "syntax_tree.h"
#include "parser.tab.c"
#include "lex.yy.c"


extern fstream info;

Node::Node(QString n,int l,int r, int i)
{name=n; left=l; right=r; number=i;}


Interval Eval(int i,Box X)
{    
Node n= syntax_tree[i];
if (n.name=="*")  return Eval(n.left,X)*Eval(n.right,X);
if (n.name=="/")  return Eval(n.left,X)/Eval(n.right,X);
if (n.name=="cos")  return cos(Eval(n.left,X));
if (n.name=="sin")  return sin(Eval(n.left,X));
if (n.name=="+")  return Eval(n.left,X)+Eval(n.right,X);
if (n.name=="-")  return Eval(n.left,X)-Eval(n.right,X);
if (n.name=="x1")  return X[1];
if (n.name=="x2")  return X[2];
return Interval(n.name.toFloat());
}

Interval Eval(Box X)
{
return Eval(syntax_tree.size()-1,X);
}


void Write_syntax_tree()
{   info<<"  Table corresponding to the abstract syntax tree \n";
    for (int i=0;i<syntax_tree.size();i++)
    {   Node n= syntax_tree[i];
        info<<i<<",\t name: "<<n.name.toStdString()<<"\t left:"<<n.left<<"\t right:"<<n.right<<'\n';
    }
    info<<"---------------------- \n";
}




int create_syntax_tree(QString f)
{
syntax_tree.clear();
QByteArray fa = f.toLatin1();
const char *fb = fa.data();
yy_scan_string(fb);  // result in syntax_tree
int err = yyparse();
Write_syntax_tree();
}




